# coding=shift_jis

# ubNXg쐬XNvg ܂Ȕ var.2.11 (2006/01/03)
# Copyright (c) 2005,2006 DukeDog <http://www.dukedog.flnet.org/>
# <^u: 8>

import sys
import re
import urllib2
import os
import md5
from optparse import OptionParser

# IP@ւ̃AhX
# kđ嗤
ARIN = "ftp://ftp.arin.net/pub/stats/arin/delegated-arin-latest"
# ׈
APNIC = "http://ftp.apnic.net/stats/apnic/delegated-apnic-latest"
# b
RIPE = "ftp://ftp.ripe.net/ripe/stats/delegated-ripencc-latest"
# 
LACNIC = "ftp://lacnic.net/pub/stats/lacnic/delegated-lacnic-latest"
# 
AfriNIC = "ftp://ftp.afrinic.net/pub/stats/afrinic/delegated-afrinic-latest"

# IP@ւ̎
NICDic = {"ARIN":ARIN, "APNIC":APNIC, "RIPE":RIPE, "LACNIC":LACNIC, "AFRINIC":AfriNIC}

# T|[g`̃Xg
Support = ["PG", "ED", "SH"]

# obNAbvt@C(ACe͊@URL)
LatestFile = {"delegated-arin-latest":ARIN, "delegated-apnic-latest":APNIC, "delegated-ripencc-latest":RIPE, "delegated-lacnic-latest":LACNIC, "delegated-afrinic-latest":AfriNIC}

# K\̃RpC
# xxx.xxx.xxx.xxx
#  G2  G3  G4  G5
# G1=R[h, G6=͈
search = re.compile("\w+\|(\w+)\|ipv4\|(\d+)\.(\d+)\.(\d+)\.(\d+)\|(\d+)\|.+")

# IPNXi[鎫(L[͐lIP)
IPListDic = {}

# epIPListDici[邽߂̎(L[͍R[h)
IPListDicDic = {}

# i[鎫(L[͍R[h)
LangDic = {}

# w肳ꂽIP@ւi[郊Xg
NICs = []

# t@Ci[郊Xg
File = []

# MD5rpϐ
oldMD5 = None
newMD5 = None

# IPAhX͈͂i[NX
#  start ... lJnIP
#  end ... lIIP(ۂ͈̔͂͂-1)
#  lang ... R[h
#  StartIP ... JnIP(`)
#  EndIP() ... `̏IIPԂ\bh
class IP:
	def __init__(self, i1, i2, i3, i4, value, lang):
		self.start = (int(i1) * 16777216) + (int(i2) * 65536) + (int(i3) * 256) + int(i4)
		self.end = self.start + int(value)
		self.lang = lang
		self.StartIP = i1 + '.' + i2 + '.' + i3 + '.' + i4
	def EndIP(self):
		ed = self.end -1
		return str((ed & 0xff000000) >> 24) + "." + str((ed & 0x00ff0000) >> 16) + "." + str((ed & 0x0000ff00) >> 8) + "." + str(ed & 0x000000ff)

# PeerGuardian`IP͈͕Ԃ֐
#  ipobj ... IPNXIuWFNg
#  label ... IP͈͂Ƃĕ\閼O
def PGGen(ipobj, label):
	return label + ':' + ipobj.StartIP + '-' + ipobj.EndIP + '\n'

# eDonkey`IP͈͕Ԃ֐
#  ipobj ... IPNXIuWFNg
#  label ... IP͈͂Ƃĕ\閼O
def EDGen(ipobj, label):
	return ipobj.StartIP + " - " + ipobj.EndIP + " , 000 , " + label + '\n'

# Shareaza`IP͈͕Ԃ֐
#  ipobj ... IPNXIuWFNg
#  label ... IP͈͂Ƃĕ\閼O
def SHGen(ipobj, label):
	return "<rule address=\"" + ipobj.StartIP + "\" action=\"deny\" type=\"address\" mask=\"" + ipobj.EndIP + "\" comment=\"" + label + "\"/>\n"

# ۂIPXg擾ēXgɊi[
#  url ... IP蓖ăt@CURL
#  iplist_dic ... IPListDic
#  lang_dic ... LangDic
def GetUrlList(url, iplist_dic, lang_dic):
	# URLJ
	f = urllib2.urlopen(url)
	for line in f.readlines():
		re_match = search.search(line)
		if re_match == None: continue
		# R[h`FbN
		if lang_dic.has_key(re_match.group(1)):
			# R[hv̂IPɓo^
			ipobj = IP(re_match.group(2), re_match.group(3), re_match.group(4), re_match.group(5), re_match.group(6), re_match.group(1))
			iplist_dic[ipobj.start] = ipobj
		else: continue
	f.close

# ۂIPXg擾ēXgɊi[(epŕʌIPListDicꍇ̊֐)
#  url ... IP蓖ăt@CURL
#  iplist_dic_dic ... epIPListDici[Ă鎫
#  lang_dic ... LangDic
def GetUrlListEx(url, iplist_dic_dic, lang_dic):
	# URLJ
	f = urllib2.urlopen(url)
	for line in f.readlines():
		re_match = search.search(line)
		if re_match == None: continue
		# R[h`FbN
		if lang_dic.has_key(re_match.group(1)):
			# R[hv̂IPɓo^
			ipobj = IP(re_match.group(2), re_match.group(3), re_match.group(4), re_match.group(5), re_match.group(6), re_match.group(1))
			iplist_dic_dic[re_match.group(1)][ipobj.start] = ipobj
		else: continue
	f.close

# t@CIPXg擾ēXgɊi[
#  file ... IP蓖ăt@C
#  iplist_dic ... IPListDic
#  lang_dic ... LangDic
def GetFileList(file, iplist_dic, lang_dic):
	# t@CJ
	f = open(file, 'r')
	for line in f.readlines():
		re_match = search.search(line)
		if re_match == None: continue
		# R[h`FbN
		if lang_dic.has_key(re_match.group(1)):
			# R[hv̂IPɓo^
			ipobj = IP(re_match.group(2), re_match.group(3), re_match.group(4), re_match.group(5), re_match.group(6), re_match.group(1))
			iplist_dic[ipobj.start] = ipobj
		else: continue
	f.close

# t@CIPXg擾ēXgɊi[(epŕʌIPListDicꍇ̊֐)
#  file ... IP蓖ăt@C
#  iplist_dic_dic ... epIPListDici[Ă鎫
#  lang_dic ... LangDic
def GetFileListEx(file, iplist_dic_dic, lang_dic,):
	# t@CJ
	f = open(file, 'r')
	for line in f.readlines():
		re_match = search.search(line)
		if re_match == None: continue
		# R[h`FbN
		if lang_dic.has_key(re_match.group(1)):
			# R[hv̂ŊY鍑IPɓo^
			ipobj = IP(re_match.group(2), re_match.group(3), re_match.group(4), re_match.group(5), re_match.group(6), re_match.group(1))
			iplist_dic_dic[re_match.group(1)][ipobj.start] = ipobj
		else: continue
	f.close


# IPNXi[鎫L[Ń\[gẴXgԂ֐
#  iplist_dic ... IPListDic
def IPListSort(iplist_dic):
	SortedList = iplist_dic.keys()
	SortedList.sort()
	return SortedList

# ubNXgo֐
#  type ... ubNXg`("PG","ED","SH")
#  list ... IPListDic
#  lang ... LangDic
#  name ... ۑt@C
def GenList(type, list, lang, name):
	SaveFile = open(name,'w')
	tmplist = IPListSort(list)
	# PeerGuardian`
	if type == "PG":
		for line in tmplist:
			if list[line].start == None: continue
			SaveFile.write(lang[list[line].lang] + ":" + list[line].StartIP + "-" + list[line].EndIP() + "\n")
	# eDonkey`
	elif type == "ED":
		for line in tmplist:
			if list[line].start == None: continue
			SaveFile.write(list[line].StartIP + " - " + list[line].EndIP() + " , 000 , " + lang[list[line].lang] + '\n')
	# Shareaza`
	elif type == "SH":
		SaveFile.write("<?xml version=\"1.0\"?>\n")
		SaveFile.write("<security xmlns=\"http://www.shareaza.com/schemas/Security.xsd\">\n")
		for line in tmplist:
			if list[line].start == None: continue
			SaveFile.write("<rule address=\"" + list[line].StartIP + "\" action=\"deny\" type=\"address\" mask=\"" + list[line].EndIP() + "\" comment=\"" + lang[list[line].lang] + "\"/>\n")
		SaveFile.write("</security>")
	SaveFile.close

# AIPIPNX
#  list ... IPListDic
def Combine(list):
	SortedList = IPListSort(list)
	SaveAddr = None
	for i in xrange(len(SortedList)-2):
		# ݂IP͈̖͂ƎIP͈͂̊Jn
		if list[SortedList[i]].end == list[SortedList[i+1]].start:
			# ܂ĂȂIP͈
			if SaveAddr == None:
				SaveAddr = i
				list[SortedList[i]].end = list[SortedList[i+1]].end
				list[SortedList[i+1]].start = None
			# ȑOɌꂽƂIP͈
			elif SaveAddr <> None:
				list[SortedList[SaveAddr]].end = list[SortedList[i+1]].end
				list[SortedList[i+1]].start = None
		else:
			SaveAddr = None

# SĂIP@ւ̃XgɕύXȂ`GbNĂύXĂ΃_E[h
# [JɕۑeXgȂbackupfBNgɃ_E[h
def ChkChange():
	# MD5p̐K\
	mdfive = re.compile("[0-9a-fA-F]{32}")
	# obNAbvtH_̃pX
	bkpath = os.getcwd() + "\\backup"
	# obNAbvtH_Ȃ΍쐬
	if not os.path.exists(bkpath):
		os.mkdir(bkpath)
	
	for item in LatestFile.keys():
		# ۑt@C݂
		if os.path.exists(bkpath + '\\' + item):
			m = md5.new()
			f = open(bkpath + '\\' + item, 'r')
			for line in f.readlines():
				m.update(line)
			# ۑt@CMD5l
			oldfile = m.hexdigest()
			f.close
			try:
				f = urllib2.urlopen(LatestFile[item]+".md5")
			except urllib2.URLError, IOError:
				print "G[: URLJ܂(" + LatestFile[item] + ")"
				print "Ώ@: b҂ĂĎsĉ"
				sys.exit(0)
			# ŏ̍sMD5lLq
			line = f.readline()
			f.close
			re_match = mdfive.search(line)
			# T[oɕۑꂢĂt@CMD5l
			new = re_match.group(0)
			# XVȂꍇ
			if oldfile == new:
				print ": t@C", item, "͍XVĂ܂"
				continue
			# XVꍇ
			else:
				print ": t@C", item, "XVĂ܂"
				f = urllib2.urlopen(LatestFile[item])
				bk = open(bkpath + '\\' + item, 'w')
				bk.writelines(f.readlines())
				f.close
				print ": t@C", item, "̍XV"
		# ۑt@C݂Ȃ
		else:
			f = urllib2.urlopen(LatestFile[item])
			bk = open(bkpath + '\\' + item, 'w')
			bk.writelines(f.readlines())
			f.close
			print ": t@C", item, "擾܂"

# fileMD5lԂBYt@C݂ȂNoneԂ
#  file ... t@C
def FileMd5(file):
	if os.path.exists(file):
		f = open(file,'r')
		m = md5.new()
		for line in f.readlines():
			m.update(line)
		f.close
		# ̂܂ܒlԂƉ̂\G[ɂȂ̂ňꎞϐɋL^
		tmp = m.hexdigest()
		return tmp
	else:
		return None

# R}hC̏
parser= OptionParser()
parser.add_option("-o", "--output", dest="output", help="o͂IPXg͂ĉ")
parser.add_option("-t", "--listtype", dest="listtype", help="o͂郊Xg`͂ĉBPeerGuardian` c PGADonkey(eMule)` c EDAShareaza` c SH ̎Ogpł܂", default="PG")
parser.add_option("-l", "--language", dest="language", help="ISOŒ߂ꂽ2̍R[h͂ĉ\nAē͂ꍇ̓J}ŋ؂ĉ")
parser.add_option("-c", "--country", dest="country", help="Xgɏo͂鍑͂ĉ\nR[hƓԂœ͂ĉ")
parser.add_option("-n", "--nic", dest="nic", help="IP@ւ̖O͂ĉBw肪ȂΑSđI܂BARIN c kđ嗤AAPNIC c ׈mARIPE c bALACNIC c āAAfriNIC c ")
parser.add_option("-f", "--file", dest="file", help="[JɕۑIP蓖ăt@Cw肵ĉB͂ꍇ̓J}ŋ؂ĉ")
parser.add_option("-O", "--optimize", dest="optimize", help="XgIP͈͂̓@w肵܂B1͂łœKA2͍ƂɍœKA0͍œKBftHg1ɂȂ܂", default="1")
parser.add_option("-g", "--getlist", dest="getlist", help="o^ĂSĂIPXg[JɕۑăXg쐬܂B0IPXg̃_E[ĥ݁A1̓_E[hƃXg̍쐬̗A2̓_E[hs킸ɕۑt@C烊Xg̍쐬s܂")
parser.add_option("-e", "--exclusion", dest="exclusion", help="Xgɓo^ȂR[h͂ĉ\nAē͂ꍇ̓J}ŋ؂ĉ")
(options, args) = parser.parse_args()

# Xg擾IvV`FbN (1)
if options.getlist == "0":
	ChkChange()
	print "SĂIPăXg擾܂"
	sys.exit(0)

# R[hw`FbN
if options.language == None:
	if options.exclusion == None:
		sys.exit("G[: R[hw肳Ă܂!")

# Xg``FbN
if options.listtype == None:
	print "x: Xg`w肳Ă܂̂ŁAftHgPeerGuardian`ŏo͂܂"
elif Support.count(options.listtype) == 0:
	sys.exit("G[: T|[g̃Xg`ł: " + options.listtype)

# ftHgo̓t@C̓o^
if options.output == None:
	if options.listtype == "PG":
		options.output = "list.txt"
		print "x: o̓t@Cw肳Ă܂̂ŃftHg\"list.txt\"gp܂"
	elif options.listtype == "ED":
		options.output = "listipfilter.dat"
		print "x: o̓t@Cw肳Ă܂̂ŃftHg\"listipfilter.dat\"gp܂"
	elif options.listtype == "SH":
		options.output = "list.xml"
		print "x: o̓t@Cw肳Ă܂̂ŃftHg\"list.xml\"gp܂"

# XVÕXgMD5l𓾂
oldMD5 = FileMd5(options.output)

# œKIvV`FbN
opt = ["0","1","2"]
if opt.count(options.optimize) == 0:
	sys.exit("G[: œKIvVŎwł̂0`2̐ł")

# IP@փXg̍쐬
if options.nic == None:
	NICs = None
else:
	options.nic = options.nic.upper()
	NICs = options.nic.split(",")
	for line in NICs:
		if not NICDic.has_key(line):
			sys.exit("G[: IP@ւ̖OԈĂ܂ : " + line + "(Ԉ)\ngpł̂ARINAAPNICARIPEALACNICAAfriNIC5ł")
		if not NICs.count(line) == 1:
			sys.exit("G[: IP蓖ċ@֖ɏd܂: " + line + "(d)")

# R[h؂蕪ĕ`FbN
if options.exclusion == None:
	LC = options.language.split(",")
else:
	LC = options.exclusion.split(",")

for letter in LC:
	if len(letter)>2 or len(letter)<2:
		sys.exit("G[: 2ȊO̍R[h͎wł܂!")

CC=[]
countrytxt = os.getcwd() + "\\country.txt"

# ؂蕪
if options.country <> None:
	CC=options.country.split(",")
	# R[h̕傫
	if len(LC)>len(CC):
		print "x: R[hƍ̐vȂߑOl߂đȂ̂͋󔒂ɂȂ܂"
		for i in range(len(LC)-len(CC)):
			# 󔒂őp
			CC.append("")
else:
	# ̎w肪Ȃ̂ōR[ĥ܂܎gp
	if os.path.exists(countrytxt) <> 1:
		print ": ̎w肪܂̂ōƂčR[ĥ܂܎gp܂"
	for i in range(len(LC)):
		CC.append(LC[i])

# R[h
# JgfBNgɍR[hƍ̃Xg(country.txt)݂ꍇÃXggp
CDNM=[]
if os.path.exists(countrytxt):
	f = open(countrytxt)
	for line in f.readlines():
		CDNM = line.split("\t")
		for name in LC:
			if options.exclusion == None:
				if CDNM[0] == name.upper():
					LangDic[CDNM[0]] = CDNM[1].replace("\r", "").replace("\n", "")
			else:
				if CDNM[0] <> name.upper():
					LangDic[CDNM[0]] = CDNM[1].replace("\r", "").replace("\n", "")
	f.close
else:
	i=0
	for name in LC:
		if options.exclusion == None:
			LangDic[name]=CC[i]
			i+=1
		else:
			print "JgfBNgɍR[hƍ̃Xg(ex. country.txt)݂܂"
			sys.exit()

# (IvV)epIPXg쐬
if options.optimize == "2":
	for country in LangDic.keys():
		IPListDicDic[country] = {}

# Xg擾IvV`FbN (2)
if options.getlist == "1":
	ChkChange()
	bkpath = os.getcwd() + "\\backup\\"
	for local in LatestFile.keys():
		File.append(bkpath + local)
elif options.getlist == "2":
	bkpath = os.getcwd() + "\\backup\\"
	for local in LatestFile.keys():
		File.append(bkpath + local)
elif options.getlist <> None:
	sys.exit("G[: Xg擾IvVŎwł̂0`2̐ł")

# t@CIvV`FbN
if options.file <> None:
	tmp = options.file.split(",")
	for path in tmp:
		if not os.path.exists(path):
			print ": t@C܂ł: " + line + "(ȃt@C)"
		else:
			File.append(path)

# t@Cw肳Ăꍇ̏
if len(File) <> 0:
	for ipfile in File:
		if options.optimize == "2":
			GetFileListEx(ipfile, IPListDicDic, LangDic)
		else:
			GetFileList(ipfile, IPListDic, LangDic)
# URLw肳Ăꍇ̏
# IP@ւ̎w肪Ȃꍇ͑SĂ̋@ւ̃Xg擾
elif NICs == None:
	for nic in NICDic.keys():
		if options.optimize == "2":
			GetUrlListEx(NICDic[nic], IPListDicDic, LangDic)
		else:
			GetUrlList(NICDic[nic], IPListDic, LangDic)
		print ": " + nic + "烊Xg擾"
else:
	for nic in NICs:
		if options.optimize == "2":
			GetUrlListEx(NICDic[nic], IPListDicDic, LangDic)
		else:
			GetUrlList(NICDic[nic], IPListDic, LangDic)
		print ": " + nic + "烊Xg擾"

# ł邾œK
if options.optimize == "1":
	Combine(IPListDic)
	GenList(options.listtype, IPListDic, LangDic, options.output)
# ɍœK
elif options.optimize == "2":
	for country in IPListDicDic:
		Combine(IPListDicDic[country])
		for key in IPListDicDic[country]:
			IPListDic[key] = IPListDicDic[country][key]
	GenList(options.listtype, IPListDic, LangDic, options.output)
# œKȂ
else:
	GenList(options.listtype, IPListDic, LangDic, options.output)

# XV`FbN
newMD5 = FileMd5(options.output)
if oldMD5 == newMD5:
	print ": Xg", options.output, "ɕύX͂܂ł"
	print ": MD5 =", newMD5
elif oldMD5 == None:
	print ": Xg", options.output, "쐬܂"
	print ": MD5 =", newMD5
else:
	print ": Xg", options.output, "XV܂"
	print ": =" + oldMD5 + "  V=" + newMD5
print "܂!"
